<?php
if (!defined('NOCSRFCHECK')) {
	define('NOCSRFCHECK', '1');
}
// Load Dolibarr environment
$res = 0;
if (!$res && file_exists("../main.inc.php")) {
	$res = @include '../main.inc.php';
}     // to work if your module directory is into dolibarr root htdocs directory
if (!$res && file_exists("../../main.inc.php")) {
	$res = @include '../../main.inc.php';
}   // to work if your module directory is into a subdir of root htdocs directory
if (!$res && file_exists("../../../main.inc.php")) {
	$res = @include '../../../main.inc.php';
}   // to work if your module directory is into a subdir of root htdocs directory
if (!$res && file_exists("../../../dolibarr/htdocs/main.inc.php")) {
	$res = @include '../../../dolibarr/htdocs/main.inc.php';
}     // Used on dev env only
if (!$res && file_exists("../../../../dolibarr/htdocs/main.inc.php")) {
	$res = @include '../../../../dolibarr/htdocs/main.inc.php';
}   // Used on dev env only
if (!$res) {
	die("Include of main fails");
}

require_once DOL_DOCUMENT_ROOT . '/core/lib/functions.lib.php';
require_once DOL_DOCUMENT_ROOT . '/product/class/product.class.php';
require_once DOL_DOCUMENT_ROOT . '/societe/class/societe.class.php';
require_once DOL_DOCUMENT_ROOT . '/variants/class/ProductCombination.class.php';

require_once DOL_DOCUMENT_ROOT . '/comm/propal/class/propal.class.php';
require_once DOL_DOCUMENT_ROOT . '/compta/facture/class/facture.class.php';
require_once DOL_DOCUMENT_ROOT . '/commande/class/commande.class.php';

dol_include_once('/ouvrage/class/ouvrage.class.php');

global $conf, $langs, $db;

$action = GETPOST("action");
$ouvrageId = GETPOST("ouvrageId");
$objectId = GETPOST("objectId");
$objectType = GETPOST("objectType");

$lineId = GETPOST("lineId");
$lineElement = GETPOST("lineElement");

function determineTableName($lineElement)
{
	switch ($lineElement) {
		case 'propal':
		case 'propale':
		case 'proposal':
			$tableName = MAIN_DB_PREFIX . "propaldet";
			break;
		case 'facture':
		case 'invoice':
			$tableName = MAIN_DB_PREFIX . "facturedet";
			break;
		case 'commande':
		case 'order':
			$tableName = MAIN_DB_PREFIX . "commandedet";
			break;
		default:
			$tableName = null;
	}

	return $tableName;
}

function determineClassLine($lineElement)
{
	switch ($lineElement) {
		case 'propal':
		case 'propale':
		case 'proposal':
			$classLine = "PropaleLigne";
			break;
		case 'facture':
		case 'invoice':
			$classLine = "FactureLigne";
			break;
		case 'commande':
		case 'order':
			$classLine = "OrderLine";
			break;
		default:
			$classLine = null;
	}

	return $classLine;
}

function determineClass($lineElement)
{
	switch ($lineElement) {
		case 'propal':
		case 'propale':
		case 'proposal':
			$classLine = "Propal";
			break;
		case 'facture':
		case 'invoice':
			$classLine = "Facture";
			break;
		case 'commande':
		case 'order':
			$classLine = "Commande";
			break;
		default:
			$classLine = null;
	}

	return $classLine;
}

function determineFkParentLabel($lineElement)
{
	switch ($lineElement) {
		case 'propal':
		case 'propale':
		case 'proposal':
			$fkParentLabel = "fk_propal";
			break;
		case 'facture':
		case 'invoice':
			$fkParentLabel = "fk_facture";
			break;
		case 'commande':
		case 'order':
			$fkParentLabel = "fk_commande";
			break;
		default:
			$fkParentLabel = null;
	}

	return $fkParentLabel;
}

function cleanArray($array)
{
	return array_map(function ($element) {
		if (!empty($element->db)) {
			$element->db = "";
		}
		if (!empty($element->fields)) {
			$element->fields = "";
		}
		if (!empty($element->dets)) {
			$element->dets = "";
		}
		return $element;
	}, $array);
}

function arrayAddIsOuvrage($array)
{
	return array_map(function ($element) {
		$element->isOuvrage = false;
		if (Ouvrage::isOuvrage($element)) {
			$element->isOuvrage = true;
		}
		return $element;
	}, $array);
}

function arrayAddStock($array)
{
	return array_map(function ($element) {
		global $db;
		if (!empty($element->fk_product)) {
			$product = new Product($db);
			$product->fetch($element->fk_product);
			$product->load_stock();
			$element->productStock = $product->stock_reel;
		}
		return $element;
	}, $array);
}

function arrayAddIsVariant($array)
{
	return array_map(function ($element) {
		global $conf, $db;

		if (!empty($element->fk_product)) {
			$sql = "SELECT fk_prod_attr, fk_prod_attr_val ";
			$sql .= "FROM " . MAIN_DB_PREFIX . "product_attribute_combination2val as pacv ";
			$sql .= "INNER JOIN " . MAIN_DB_PREFIX . "product_attribute as pa ";
			$sql .= "ON pacv.fk_prod_attr = pa.rowid ";
			$sql .= "WHERE fk_prod_combination = (";
			$sql .= "SELECT DISTINCT rowid FROM ";
			$sql .= MAIN_DB_PREFIX . "product_attribute_combination ";
			$sql .= "WHERE fk_product_child = " . $element->fk_product . " ";
			$sql .= "AND entity = " . $conf->entity . ") ";
			$sql .= "AND entity = " . $conf->entity;

			$arrayCombinations = array();
			$parentID = -1;

			$resql = $db->query($sql);
			if ($resql) {
				while ($attr = $db->fetch_object($resql)) {
					$arrayCombinations[$attr->fk_prod_attr] = $attr->fk_prod_attr_val;
				}
				$sql = "SELECT DISTINCT fk_product_parent ";
				$sql .= "FROM " . MAIN_DB_PREFIX . "product_attribute_combination as pac ";
				$sql .= "WHERE fk_product_child = " . $element->fk_product . " ";
				$sql .= "AND entity = " . $conf->entity;
				$resql = $db->query($sql);
				if ($resql) {
					while ($parent = $db->fetch_object($resql)) {
						$parentID = $parent->fk_product_parent;
					}
				}
				if ($parentID == -1) {
					$sql = "SELECT DISTINCT fk_product_parent ";
					$sql .= "FROM " . MAIN_DB_PREFIX . "product_attribute_combination as pac ";
					$sql .= "WHERE fk_product_parent = " . $element->fk_product . " ";
					$sql .= "AND entity = " . $conf->entity;
					$resql = $db->query($sql);
					if ($resql) {
						while ($parent = $db->fetch_object($resql)) {
							$parentID = $parent->fk_product_parent;
						}
					}
				}
			}

			$element->arrayCombinations = $arrayCombinations;
			$element->parentID = $parentID;
		}

		return $element;
	}, $array);
}

if ($action == "retrieveOuvrage") {
	$ouvrage = new Ouvrage($db);
	$ouvrage->fetch($ouvrageId);

	$object = new $objectType($db);
	$object->fetch($objectId);

	$lines = array();
	foreach ($ouvrage->dets as $det) {
		if (!empty($det['product'])) {
			$product = new Product($db);
			$product->fetch($det['product']);

			$lines[] = ["element" => "product", "id" => $product->id, "qty" => $det['qty'], "fk_parent" => $ouvrage->id,"default-qty" => $det['qty']];
			$ouvrage->unitPrice += $det['qty'] * floatval($ouvrage->getPrice($product, $object));
		} else if (!empty($det['ouvrage'])) {
			$subWork = new Ouvrage($db);
			$subWork->fetch($det['ouvrage']);

			$subWork->qty = $det['qty'];

			$subWorkLines = array();

			foreach ($subWork->dets as $d) {
				if (!empty($d['product'])) {
					$product = new Product($db);
					$product->fetch($d['product']);

					$subWorkLines[] = ["element" => "product", "id" => $product->id, "default-qty" => $d['qty'], "qty" => ($d['qty'] * $det['qty']), "fk_parent" => $subWork->id];

					$ouvrage->unitPrice += $d['qty'] * floatval($ouvrage->getPrice($product, $object));
					$subWork->unitPrice += $d['qty'] * floatval($ouvrage->getPrice($product, $object));
				}
			}

			$lines[] = ["element" => "ouvrage", "ouvrage" => $subWork, "fk_parent" => $ouvrage->id];
			$lines = array_merge($lines, $subWorkLines);
		}
	}

	$lines = cleanArray($lines);


	include_once dol_buildpath("/ouvrage/ajax/ajaxOuvrageForm.php");
}

if ($action == "retrieveLine") {

	$ouvrage = new Ouvrage($db);
	$ouvrage->fetch($ouvrageId);


	$tableName = determineTableName($lineElement);
	$classLine = determineClassLine($lineElement);

	$objectClass = determineClass($lineElement);
	$fkParentLabel = determineFkParentLabel($lineElement);

	if (empty($tableName) || empty($classLine)) {
		$response = array(
			"error" => 1,
			"message" => "lineElement is incorrect"
		);
		echo json_encode($response);
		exit();
	}

	$sql = "SELECT rowid AS line FROM ( ";
	$sql .= "SELECT * FROM " . $tableName . " ORDER BY rang ";
	$sql .= ") AS table_sorted, ";
	$sql .= "( SELECT @pv := '" . $lineId . "' ) AS initialisation ";
	$sql .= "WHERE find_in_set(fk_parent_line, @pv) AND length(@pv := concat(@pv, ',', rowid))";
	$resql = $db->query($sql);
	if ($resql) {
		$line = new $classLine($db);
		$line->fetch($lineId);

		$object = new $objectClass($db);
		$object->fetch($line->$fkParentLabel);
		$object->fetch_thirdparty();

		$lines[] = $line;
		while (($lId = $db->fetch_object($resql)->line) !== null) {
			$line = new $classLine($db);
			$line->fetch($lId);

			$lines[] = $line;
		}
	} else {
		$response = array(
			"error" => 2,
			"message" => "Error SQL"
		);
		echo json_encode($response);
		exit();
	}

	$lines = cleanArray($lines);
	$lines = arrayAddIsOuvrage($lines);
	$lines = arrayAddStock($lines);
	if ($conf->variants->enabled) {
		$lines = arrayAddIsVariant($lines);
	}

	$ouvrage = array_shift($lines);
	include_once dol_buildpath("/ouvrage/ajax/ajaxOuvrageFormModification.php");
}
