<?php
/**
 *  \file       /ouvrage/class/html.form_ouvrage.class.php
 *  \ingroup    ouvrage
 *  \brief      Class ouvrage HTML
 */

/**
 * Class to manage building of HTML components
 */
class FormOuvrage extends Form
{
	var $db;
	var $error;

	/**
	 * Constructor
	 *
	 * @param DoliDB $db handler
	 */
	function __construct($db)
	{
		$this->db = $db;

		return 1;
	}

	function selectOuvrageInput($htmlname = 'ouvrageid', $ouvrageId = '0') {
		global $langs;

		$out = "";

		$out .= '<div style="display: flex">';
		$out .= '<input type="hidden" name="'. $htmlname .'" id="'. $htmlname .'" value="">';
		$out .= $langs->trans("RefOrLabel") . ' : ';
		$out .= '<div id="div_search_'. $htmlname .'" style="margin-left:4px">';
		$out .= '<input type="text" class="minwidth100 ui-autocomplete-input" name="search_'. $htmlname .'" id="search_'. $htmlname .'" value="" autocomplete="on">';
		$out .= '<div id="suggestions_'. $htmlname .'" style="display: block"></div>';
		$out .= '</div>';
		$out .= '</div>';

		$out .= '<script>
			$(document).ready(function() {
			    var url = "'. dol_buildpath('/custom/ouvrage/ajax/getOuvrage.php', 1) .'";

			    $("#search_'. $htmlname .'").keyup(function(e) {
			        if (e.keyCode != 9 && e.keyCode != 13) {
			        	var search = $("#search_'. $htmlname .'").val();

			            $.ajax({
                            url: url,
                            type: "POST",
                            data: {
                                "action": "searchWorks",
                                "search": search,
                                "ouvrageId": '. $ouvrageId .',
                                "noSubworks" : "1",
                            },
                        }).done(function(data) {
                        	data = JSON.parse(data);

							if (data.error == 0) {
								$("#suggestions_'. $htmlname .'").html(data.suggestions);
							} else if (data.error == 1) {
							    $("#suggestions_'. $htmlname .'").html(null);
							} else {
							    console.log(data.message);
							}
                        }).fail(function() {
                            console.log("FAIL");
                        });
			        }
			    });
			});
		</script>';

		return $out;
	}

	function select_ouvrage($htmlname = 'ouvrageid')
	{
		global $langs, $conf;

		$out = '';

		include_once DOL_DOCUMENT_ROOT . '/core/lib/ajax.lib.php';
		$comboenhancement = ajax_combobox($htmlname, null, $conf->global->PRODUIT_USE_SEARCH_TO_SELECT);
		$out .= $comboenhancement;

		$sql = "SELECT w.* FROM " . MAIN_DB_PREFIX . "works as w";
		$sql .= " WHERE `entity` = " . $conf->entity;

		$resql = $this->db->query($sql);

		$out .= '<select class="flat" name="' . $htmlname . '" id="' . $htmlname . '" style="min-width:40%">';
		$out .= '<option value="0"></option>';
		while ($i < $this->db->num_rows($resql)) {
			$obj = $this->db->fetch_object($resql);

			$out .= '<option value="' . $obj->rowid . '">' . $obj->ref . ' - ' . $obj->label . '</option>';

			$i++;
		}

		$out .= '</select>';

		return $out;
	}
}
